Blame SOURCES/aliyun-vpc-move-ip-2-fixes.patch

05afe3
From db3df55a6f7097e1da7d77eb361e9e7560f13353 Mon Sep 17 00:00:00 2001
05afe3
From: Oyvind Albrigtsen <oalbrigt@redhat.com>
05afe3
Date: Tue, 24 Jul 2018 13:57:08 +0200
05afe3
Subject: [PATCH] aliyun-vpc-move-ip: fixes
05afe3
05afe3
---
05afe3
 doc/man/Makefile.am          |   1 +
05afe3
 heartbeat/Makefile.am        |   1 +
05afe3
 heartbeat/aliyun-vpc-move-ip | 336 ++++++++++++++++++++++++-------------------
05afe3
 3 files changed, 189 insertions(+), 149 deletions(-)
05afe3
 mode change 100644 => 100755 heartbeat/aliyun-vpc-move-ip
05afe3
05afe3
diff --git a/doc/man/Makefile.am b/doc/man/Makefile.am
05afe3
index 3ac0569de..fc9a67161 100644
05afe3
--- a/doc/man/Makefile.am
05afe3
+++ b/doc/man/Makefile.am
05afe3
@@ -93,6 +93,7 @@ man_MANS	       = ocf_heartbeat_AoEtarget.7 \
05afe3
                           ocf_heartbeat_WinPopup.7 \
05afe3
                           ocf_heartbeat_Xen.7 \
05afe3
                           ocf_heartbeat_Xinetd.7 \
05afe3
+                          ocf_heartbeat_aliyun-vpc-move-ip.7 \
05afe3
                           ocf_heartbeat_anything.7 \
05afe3
                           ocf_heartbeat_apache.7 \
05afe3
                           ocf_heartbeat_asterisk.7 \
05afe3
diff --git a/heartbeat/Makefile.am b/heartbeat/Makefile.am
05afe3
index d4750bf09..6adc6bc3c 100644
05afe3
--- a/heartbeat/Makefile.am
05afe3
+++ b/heartbeat/Makefile.am
05afe3
@@ -90,6 +90,7 @@ ocf_SCRIPTS	     =  AoEtarget		\
05afe3
 			Xen			\
05afe3
 			Xinetd			\
05afe3
 			ZFS			\
05afe3
+			aliyun-vpc-move-ip	\
05afe3
 			anything		\
05afe3
 			apache			\
05afe3
 			asterisk		\
05afe3
diff --git a/heartbeat/aliyun-vpc-move-ip b/heartbeat/aliyun-vpc-move-ip
05afe3
old mode 100644
05afe3
new mode 100755
05afe3
index bc97822a8..108feb247
05afe3
--- a/heartbeat/aliyun-vpc-move-ip
05afe3
+++ b/heartbeat/aliyun-vpc-move-ip
05afe3
@@ -1,30 +1,19 @@
05afe3
-#!/bin/bash
05afe3
+#!/bin/sh
05afe3
 #
05afe3
 # OCF resource agent to move an IP address within a VPC in the Aliyun
05afe3
 # Based on code of Markus Guertler (GitHub AWS-VPC-move-IP)
05afe3
 # Based on code of Adam Gandelman (GitHub ec2-resource-agents/elasticip)
05afe3
 #
05afe3
 
05afe3
-###############################################################################
05afe3
-# For testing purposes delete OCF_ROOT after testing
05afe3
-OCF_ROOT=/usr/lib/ocf/
05afe3
-#
05afe3
-# INIT
05afe3
-#: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/resource.d/heartbeat}
05afe3
-#if [ -f ${OCF_FUNCTIONS_DIR}/.ocf-shellfuncs ]; then
05afe3
-#  . ${OCF_FUNCTIONS_DIR}/.ocf-shellfuncs
05afe3
-#fi
05afe3
-
05afe3
 #######################################################################
05afe3
 # Initialization:
05afe3
-
05afe3
-: ${OCF_FUNCTIONS=${OCF_ROOT}/resource.d/heartbeat/.ocf-shellfuncs}
05afe3
-. ${OCF_FUNCTIONS}
05afe3
-: ${__OCF_ACTION=$1}
05afe3
-export HOME=/root
05afe3
+: ${OCF_FUNCTIONS_DIR=${OCF_ROOT}/lib/heartbeat}
05afe3
+. ${OCF_FUNCTIONS_DIR}/ocf-shellfuncs
05afe3
 #######################################################################
05afe3
 
05afe3
- 
05afe3
+# aliyuncli doesnt work without HOME parameter
05afe3
+export HOME="/root"
05afe3
+
05afe3
 USAGE="usage: $0 {start|stop|status|meta-data}";
05afe3
 ###############################################################################
05afe3
 
05afe3
@@ -36,8 +25,96 @@ USAGE="usage: $0 {start|stop|status|meta-data}";
05afe3
 ###############################################################################
05afe3
 
05afe3
 
05afe3
-metadata() {
05afe3
-cat <
05afe3
+
05afe3
+ip_get_and_configure() {
05afe3
+	ocf_log debug "function: ip_get_and_configure"
05afe3
+
05afe3
+	ROUTE_TO_INSTANCE="$($cmd |grep $OCF_RESKEY_address | awk '{ print $3 }')"
05afe3
+
05afe3
+	if [ "$ECS_INSTANCE_ID" != "$ROUTE_TO_INSTANCE" ]; then
05afe3
+		if [ -n "$ROUTE_TO_INSTANCE" ]; then
05afe3
+			ip_drop
05afe3
+		fi
05afe3
+
05afe3
+		cmd="aliyuncli vpc CreateRouteEntry --RouteTableId $OCF_RESKEY_routing_table --DestinationCidrBlock ${OCF_RESKEY_address}/32 --NextHopId $ECS_INSTANCE_ID --NextHopType Instance --output text"
05afe3
+		ocf_log debug "executing command: $cmd"
05afe3
+		$cmd
05afe3
+		rc=$?
05afe3
+		while [ $rc -ne 0 ]; do
05afe3
+			sleep 1
05afe3
+			cmd="aliyuncli vpc CreateRouteEntry --RouteTableId $OCF_RESKEY_routing_table --DestinationCidrBlock ${OCF_RESKEY_address}/32 --NextHopId $ECS_INSTANCE_ID --NextHopType Instance --output text"
05afe3
+			ocf_log debug "executing command: $cmd"
05afe3
+			$cmd
05afe3
+			rc=$?
05afe3
+		done
05afe3
+		wait_for_started
05afe3
+	fi
05afe3
+
05afe3
+
05afe3
+	# Reconfigure the local ip address
05afe3
+	ip addr add "${OCF_RESKEY_address}/32" dev $OCF_RESKEY_interface
05afe3
+	rc=$?
05afe3
+	if [ $rc -ne 0 ]; then
05afe3
+		ocf_log err "command failed, rc: $rc"
05afe3
+		return $OCF_ERR_GENERIC
05afe3
+	fi
05afe3
+
05afe3
+	ocf_log debug "IP added"
05afe3
+
05afe3
+	return $OCF_SUCCESS
05afe3
+}
05afe3
+
05afe3
+ip_drop() {
05afe3
+	ocf_log debug "function: ip_drop"
05afe3
+	cmd="ip addr delete ${OCF_RESKEY_address}/32 dev $OCF_RESKEY_interface"
05afe3
+	ocf_log debug "executing command: $cmd"
05afe3
+	$cmd
05afe3
+	rc=$?
05afe3
+	if [ $rc -ne 0 ] && [ $rc -ne 2 ]; then
05afe3
+		ocf_log err "command failed, rc $rc"
05afe3
+		return $OCF_ERR_GENERIC
05afe3
+	fi
05afe3
+
05afe3
+	cmd="aliyuncli vpc DeleteRouteEntry --RouteTableId $OCF_RESKEY_routing_table --DestinationCidrBlock ${OCF_RESKEY_address}/32 --NextHopId $ROUTE_TO_INSTANCE --output text"
05afe3
+	ocf_log debug "executing command: $cmd"
05afe3
+	$cmd
05afe3
+	if [ $? -ne 0 ]; then
05afe3
+		ocf_log err "command failed, rc: $rc"
05afe3
+		return $OCF_ERR_GENERIC
05afe3
+	fi
05afe3
+	wait_for_deleted
05afe3
+
05afe3
+	ocf_log debug "IP dropped"
05afe3
+
05afe3
+	return $OCF_SUCCESS
05afe3
+}
05afe3
+
05afe3
+wait_for_started() {
05afe3
+	cmd="aliyuncli vpc DescribeRouteTables --RouteTableId $OCF_RESKEY_routing_table --output text"
05afe3
+	ocf_log debug "executing command: $cmd"
05afe3
+	ROUTE_TO_INSTANCE="$($cmd | grep $OCF_RESKEY_address | awk '{ print $3 }')"
05afe3
+
05afe3
+	while [ "$ECS_INSTANCE_ID" != "$ROUTE_TO_INSTANCE" ]; do
05afe3
+		sleep 3
05afe3
+		cmd="aliyuncli vpc DescribeRouteTables --RouteTableId $OCF_RESKEY_routing_table --output text"
05afe3
+		ocf_log debug "executing command: $cmd"
05afe3
+		ROUTE_TO_INSTANCE="$($cmd | grep $OCF_RESKEY_address | awk '{ print $3 }')"
05afe3
+	done
05afe3
+}
05afe3
+
05afe3
+wait_for_deleted() {
05afe3
+	ROUTE_TO_INSTANCE="$($cmd |grep $OCF_RESKEY_address | awk '{ print $3 }')"
05afe3
+
05afe3
+	 while [ ! -z "$ROUTE_TO_INSTANCE" ]; do
05afe3
+		sleep 1
05afe3
+		cmd="aliyuncli vpc DescribeRouteTables --RouteTableId $OCF_RESKEY_routing_table --output text"
05afe3
+		ocf_log debug "executing command: $cmd"
05afe3
+		ROUTE_TO_INSTANCE="$($cmd |grep $OCF_RESKEY_address | awk '{ print $3 }')"
05afe3
+	 done
05afe3
+}
05afe3
+
05afe3
+ecs_ip_metadata() {
05afe3
+	cat <
05afe3
 
05afe3
 
05afe3
 <resource-agent name="vpc-move-ip">
05afe3
@@ -74,8 +151,8 @@ Name of the network interfacen, i.e. eth0
05afe3
 Valid Aliyun CLI profile name
05afe3
 </longdesc>
05afe3
 <shortdesc lang="en">profile name</shortdesc>
05afe3
-<content type="string" default="default" /> 
05afe3
-</parameter> 
05afe3
+<content type="string" default="default" />
05afe3
+</parameter>
05afe3
 </parameters>
05afe3
 <actions>
05afe3
 <action name="start" timeout="180" />
05afe3
@@ -88,171 +165,132 @@ Valid Aliyun CLI profile name
05afe3
 END
05afe3
 }
05afe3
 
05afe3
-debugger() {
05afe3
-	ocf_log info "DEBUG: $1"
05afe3
-}
05afe3
-
05afe3
 ecs_ip_validate() {
05afe3
-	debugger "function: validate"
05afe3
-	
05afe3
+	ocf_log debug "function: validate"
05afe3
+
05afe3
 	# IP address
05afe3
-	[[ -z "$OCF_RESKEY_address" ]] && ocf_log error "IP address parameter not set $OCF_RESKEY_ADDRESS!" && exit $OCF_ERR_CONFIGURED
05afe3
-	
05afe3
+	if [ -z "$OCF_RESKEY_address" ]; then
05afe3
+		ocf_log err "IP address parameter not set $OCF_RESKEY_ADDRESS!"
05afe3
+		exit $OCF_ERR_CONFIGURED
05afe3
+	fi
05afe3
+
05afe3
 	# Network Interface
05afe3
-	[[ -z "$OCF_RESKEY_interface" ]] && ocf_log error "Network interface parameter not set $OCF_RESKEY_INTERFACE!" && exit $OCF_ERR_CONFIGURED
05afe3
-	
05afe3
+	if [ -z "$OCF_RESKEY_interface" ]; then
05afe3
+		ocf_log err "Network interface parameter not set $OCF_RESKEY_INTERFACE!"
05afe3
+		exit $OCF_ERR_CONFIGURED
05afe3
+	fi
05afe3
+
05afe3
 	# Routing Table
05afe3
-	[[ -z "$OCF_RESKEY_routing_table" ]] && ocf_log error "Routing table parameter not set $OCF_RESKEY_ROUTING_TABLE!" && exit $OCF_ERR_CONFIGURED
05afe3
-	
05afe3
-	ECS_INSTANCE_ID="$(curl -s http://100.100.100.200/latest/meta-data/instance-id)"
05afe3
+	if [ -z "$OCF_RESKEY_routing_table" ]; then
05afe3
+		ocf_log err "Routing table parameter not set $OCF_RESKEY_ROUTING_TABLE!"
05afe3
+		exit $OCF_ERR_CONFIGURED
05afe3
+	fi
05afe3
 
05afe3
 	if [ -z "${ECS_INSTANCE_ID}" ]; then
05afe3
 		ocf_exit_reason "Instance ID not found. Is this a ECS instance?"
05afe3
 		return $OCF_ERR_GENERIC
05afe3
 	fi
05afe3
-	
05afe3
-	return $OCF_SUCCESS
05afe3
-}
05afe3
 
05afe3
-ecs_ip_monitor() {
05afe3
-	ecs_ip_validate
05afe3
-	debugger "function: ecsip_monitor: check routing table"
05afe3
-	cmd="aliyuncli vpc DescribeRouteTables --RouteTableId $OCF_RESKEY_routing_table --output text"
05afe3
-	debugger "executing command: $cmd"
05afe3
-	ROUTE_TO_INSTANCE="$($cmd |grep $OCF_RESKEY_address | awk '{ print $3 }')"
05afe3
-	if [ -z "$ROUTE_TO_INSTANCE" ]; then 
05afe3
-		ROUTE_TO_INSTANCE="<unknown>"
05afe3
-	fi
05afe3
-	
05afe3
-	[[ "$ECS_INSTANCE_ID" != "$ROUTE_TO_INSTANCE" ]] && debugger "not routed to this instance ($ECS_INSTANCE_ID) but to instance $ROUTE_TO_INSTANCE" && return $OCF_NOT_RUNNING 
05afe3
-	cmd="ping -W 1 -c 1 $OCF_RESKEY_address"
05afe3
-	debugger "executing command: $cmd"
05afe3
-	$cmd > /dev/null
05afe3
-	[[ $? -gt 0 ]]  && debugger "IP $OCF_RESKEY_address not locally reachable via ping on this system" && return $OCF_NOT_RUNNING
05afe3
-	debugger "routed in VPC and locally reachable"
05afe3
-	return $OCF_SUCCESS	
05afe3
-}
05afe3
-
05afe3
-
05afe3
-ecs_ip_drop() {
05afe3
-	debugger "function: ecsip_drop"
05afe3
-	cmd="ip addr delete ${OCF_RESKEY_address}/32 dev $OCF_RESKEY_interface"
05afe3
-	debugger "executing command: $cmd"
05afe3
-	$cmd
05afe3
-	rc=$?
05afe3
-	[[ $rc -gt 2 ]] && debugger "command failed, rc $rc" && return $OCF_ERR_GENERIC
05afe3
-	debugger "command succeeded"
05afe3
 	return $OCF_SUCCESS
05afe3
 }
05afe3
 
05afe3
-wait_for_deleted() {
05afe3
-  while [ ! -z "$ROUTE_TO_INSTANCE" ]; do
05afe3
-		sleep 1
05afe3
-		cmd="aliyuncli vpc DescribeRouteTables --RouteTableId $OCF_RESKEY_routing_table --output text"
05afe3
-		debugger "executing command: $cmd"
05afe3
-		ROUTE_TO_INSTANCE="$($cmd |grep $OCF_RESKEY_address | awk '{ print $3 }')"
05afe3
-  done
05afe3
-	sleep 5
05afe3
-}
05afe3
+ecs_ip_start() {
05afe3
+	ocf_log info "ECS: Moving IP address $OCF_RESKEY_address to this host by adjusting routing table $OCF_RESKEY_routing_table"
05afe3
 
05afe3
-wait_for_started() {
05afe3
-	cmd="aliyuncli vpc DescribeRouteTables --RouteTableId $OCF_RESKEY_routing_table --output text"
05afe3
-	debugger "executing command: $cmd"
05afe3
-	ROUTE_TO_INSTANCE="$($cmd |grep $OCF_RESKEY_address | awk '{ print $3 }')"
05afe3
-		
05afe3
-  while [ "$ECS_INSTANCE_ID" != "$ROUTE_TO_INSTANCE" ]; do
05afe3
-		sleep 1
05afe3
-		cmd="aliyuncli vpc DescribeRouteTables --RouteTableId $OCF_RESKEY_routing_table --output text"
05afe3
-		debugger "executing command: $cmd"
05afe3
-		ROUTE_TO_INSTANCE="$($cmd |grep $OCF_RESKEY_address | awk '{ print $3 }')"
05afe3
-  done
05afe3
-	sleep 5
05afe3
-}
05afe3
+	ecs_ip_monitor
05afe3
+	if [ $? = $OCF_SUCCESS ]; then
05afe3
+		ocf_log info "ECS: $OCF_RESKEY_address already started"
05afe3
+		return $OCF_SUCCESS
05afe3
+	fi
05afe3
 
05afe3
-ecs_ip_get_and_configure() {
05afe3
-	debugger "function: ecsip_get_and_configure"
05afe3
-  
05afe3
- if [ "$ECS_INSTANCE_ID" != "$ROUTE_TO_INSTANCE" ]; then 
05afe3
- 
05afe3
-     if [ $ROUTE_TO_INSTANCE != "<unknown>" ]; then
05afe3
-      # Adjusting the routing table
05afe3
-        cmd="aliyuncli  vpc DeleteRouteEntry --RouteTableId $OCF_RESKEY_routing_table --DestinationCidrBlock ${OCF_RESKEY_address}/32 --NextHopId $ROUTE_TO_INSTANCE --output text"
05afe3
-        debugger "executing command: $cmd"
05afe3
-        $cmd
05afe3
-        rc=$?
05afe3
-        [[ $rc != 0 ]] && debugger "command failed, rc: $rc" && return $OCF_ERR_GENERIC
05afe3
-        #wait_for_deleted
05afe3
-        sleep 3
05afe3
-      fi
05afe3
-      
05afe3
-      cmd="aliyuncli  vpc CreateRouteEntry --RouteTableId $OCF_RESKEY_routing_table --DestinationCidrBlock ${OCF_RESKEY_address}/32 --NextHopId $ECS_INSTANCE_ID --NextHopType Instance --output text"
05afe3
-      debugger "executing command: $cmd"
05afe3
-      $cmd
05afe3
-      rc=$?
05afe3
-      #[[ $rc != 0 ]] && debugger "command failed, rc: $rc" && return $OCF_ERR_GENERIC
05afe3
-		  while [ $rc != 0 ]; do
05afe3
-				sleep 2
05afe3
-				cmd="aliyuncli  vpc CreateRouteEntry --RouteTableId $OCF_RESKEY_routing_table --DestinationCidrBlock ${OCF_RESKEY_address}/32 --NextHopId $ECS_INSTANCE_ID --NextHopType Instance --output text"
05afe3
-				debugger "executing command: $cmd"
05afe3
-				$cmd
05afe3
-				rc=$?
05afe3
-			done
05afe3
-      wait_for_started
05afe3
+	ocf_log info "ECS: Adjusting routing table and locally configuring IP address"
05afe3
+	ip_get_and_configure
05afe3
+	rc=$?
05afe3
+	if [ $rc -ne 0 ]; then
05afe3
+		ocf_log err "Received $rc from 'aliyun cli'"
05afe3
+		return $OCF_ERR_GENERIC
05afe3
 	fi
05afe3
-  
05afe3
-  
05afe3
-	# Reconfigure the local ip address
05afe3
-	ecs_ip_drop
05afe3
-	ip addr add "${OCF_RESKEY_address}/32" dev $OCF_RESKEY_interface
05afe3
+
05afe3
+	ecs_ip_monitor
05afe3
 	rc=$?
05afe3
-	[[ $rc != 0 ]] && debugger "command failed, rc: $rc" && return $OCF_ERR_GENERIC
05afe3
-	debugger "-success"
05afe3
+	if [ $rc -ne $OCF_SUCCESS ]; then
05afe3
+		ocf_log err "IP address couldn't be configured on this host (IP: $OCF_RESKEY_address, Interface: $OCF_RESKEY_interface)"
05afe3
+		return $rc
05afe3
+	fi
05afe3
+
05afe3
 	return $OCF_SUCCESS
05afe3
 }
05afe3
 
05afe3
 ecs_ip_stop() {
05afe3
 	ocf_log info "ECS: Bringing down IP address $OCF_RESKEY_address"
05afe3
-	ecs_ip_validate 
05afe3
+
05afe3
 	ecs_ip_monitor
05afe3
-	[[ $? == $OCF_NOT_RUNNING ]] && ocf_log info "ECS: Address $OCF_RESKEY_address already down" && return $OCF_SUCCESS
05afe3
-	ecs_ip_drop
05afe3
-	[[ $? != $OCF_SUCCESS ]] && return $OCF_ERR_GENERIC
05afe3
+	if [ $? = $OCF_NOT_RUNNING ]; then
05afe3
+		ocf_log info "ECS: Address $OCF_RESKEY_address already down"
05afe3
+		return $OCF_SUCCESS
05afe3
+	fi
05afe3
+
05afe3
+	ip_drop
05afe3
+	if [ $? -ne $OCF_SUCCESS ]; then
05afe3
+		ocf_log err "ECS: Couldn't drop IP address $OCF_RESKEY_address on interface $OCF_RESKEY_interface."
05afe3
+		return $OCF_ERR_GENERIC
05afe3
+	fi
05afe3
+
05afe3
 	ecs_ip_monitor
05afe3
-	[[ $? == $OCF_NOT_RUNNING ]] && ocf_log info "ECS: Successfully brought down $OCF_RESKEY_address" && return $OCF_SUCCESS
05afe3
-	ocf_log error "ECS: Couldn't bring down IP address $OCF_RESKEY_address on interface $OCF_RESKEY_interface." 
05afe3
+	if [ $? = $OCF_NOT_RUNNING ]; then
05afe3
+		ocf_log info "ECS: Successfully brought down $OCF_RESKEY_address"
05afe3
+		return $OCF_SUCCESS
05afe3
+	fi
05afe3
+
05afe3
+	ocf_log err "ECS: Couldn't bring down IP address $OCF_RESKEY_address on interface $OCF_RESKEY_interface."
05afe3
 	return $OCF_ERR_GENERIC
05afe3
 }
05afe3
 
05afe3
-ecs_ip_start() {
05afe3
-	ocf_log info "ECS: Moving IP address $OCF_RESKEY_address to this host by adjusting routing table $OCF_RESKEY_routing_table"
05afe3
-	ecs_ip_validate
05afe3
-	ecs_ip_monitor
05afe3
-	[[ $? == $OCF_SUCCESS ]] && ocf_log info "ECS: $OCF_RESKEY_address already started" && return $OCF_SUCCESS
05afe3
-	ocf_log info "ECS: Adjusting routing table and locally configuring IP address"
05afe3
-	ecs_ip_get_and_configure 
05afe3
-	[[ $? != 0 ]] && ocf_log error "Received $? from 'aliyun cli'" && return $OCF_ERR_GENERIC
05afe3
-  return $OCF_SUCCESS
05afe3
-	ecs_ip_monitor
05afe3
-	[[ $? == $OCF_SUCCESS ]] &&  return $?
05afe3
-	ocf_log error "ECS: IP address couldn't be configured on this host (IP: $OCF_RESKEY_address, Interface: $OCF_RESKEY_interface)"
05afe3
-	return $OCF_ERR_GENERIC
05afe3
+ecs_ip_monitor() {
05afe3
+	ocf_log debug "function: ecsip_monitor: check routing table"
05afe3
+	cmd="aliyuncli vpc DescribeRouteTables --RouteTableId $OCF_RESKEY_routing_table --output text"
05afe3
+	ocf_log debug "executing command: $cmd"
05afe3
+
05afe3
+	ROUTE_TO_INSTANCE="$($cmd |grep $OCF_RESKEY_address | awk '{ print $3 }')"
05afe3
+
05afe3
+	if [ "$ECS_INSTANCE_ID" != "$ROUTE_TO_INSTANCE" ]; then
05afe3
+		ocf_log debug "not routed to this instance ($ECS_INSTANCE_ID) but to instance $ROUTE_TO_INSTANCE"
05afe3
+		return $OCF_NOT_RUNNING
05afe3
+	fi
05afe3
+
05afe3
+	cmd="ping -W 1 -c 1 $OCF_RESKEY_address"
05afe3
+	ocf_log debug "executing command: $cmd"
05afe3
+	$cmd > /dev/null
05afe3
+	if [ $? -ne 0 ]; then
05afe3
+		ocf_log debug "IP $OCF_RESKEY_address not locally reachable via ping on this system"
05afe3
+		return $OCF_NOT_RUNNING
05afe3
+	fi
05afe3
+	ocf_log debug "routed in VPC and locally reachable"
05afe3
+	return $OCF_SUCCESS
05afe3
 }
05afe3
 
05afe3
+
05afe3
 ###############################################################################
05afe3
 #
05afe3
 # MAIN
05afe3
 #
05afe3
 ###############################################################################
05afe3
 
05afe3
-case $__OCF_ACTION in 
05afe3
-	meta-data) metadata
05afe3
+case $__OCF_ACTION in
05afe3
+	meta-data) ecs_ip_metadata
05afe3
 		   exit $OCF_SUCCESS;;
05afe3
-	monitor)
05afe3
-		ecs_ip_monitor;;
05afe3
-	stop)
05afe3
-		ecs_ip_stop;;
05afe3
 	validate-all) ecs_ip_validate;;
05afe3
+esac
05afe3
+
05afe3
+ECS_INSTANCE_ID="$(curl -s http://100.100.100.200/latest/meta-data/instance-id)"
05afe3
+
05afe3
+case $__OCF_ACTION in
05afe3
 	start)
05afe3
+		ecs_ip_validate
05afe3
 		ecs_ip_start;;
05afe3
+	stop)
05afe3
+		ecs_ip_stop;;
05afe3
+	monitor)
05afe3
+		ecs_ip_monitor;;
05afe3
 	*)	exit $OCF_ERR_UNIMPLEMENTED;;
05afe3
-esac
05afe3
\ No newline at end of file
05afe3
+esac